# -*- coding: utf-8 -*-
#
# File: jidTreeVocabularyWidget.py
#
# Copyright (c) 2009 by []
# Generator: ArchGenXML Version 2.3
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Acquisition import aq_base

from Products.CMFCore.utils import getToolByName

from Products.Archetypes.Registry import registerWidget
from Products.Archetypes.utils import DisplayList
from Products.Archetypes import config as atconfig
from Products.Archetypes.Widget import *
from Products.Archetypes.Widget import TypesWidget

from Products.jidTreeVocabularyWidget import config

##code-section module-header #fill in your manual code here
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from Products.CMFCore.utils import getToolByName
from string import replace, split
from types import ListType, StringTypes
from Products.CMFPlone.utils import log, log_exc, safe_hasattr
##/code-section module-header

from zope.interface import implements
from Products.Archetypes.Widget import MultiSelectionWidget
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin


class jidTreeVocabularyWidget(MultiSelectionWidget):
    """
    """
    ##code-section class-header #fill in your manual code here
    populateSelectionTemplate = ViewPageTemplateFile('skins/jidtreevocabularywidget_templates/populateSelectionTemplate.pt')
    clearSelectionTemplate = ViewPageTemplateFile('skins/jidtreevocabularywidget_templates/clearSelectionTemplate.pt')
    ##/code-section class-header


    _properties = MultiSelectionWidget._properties.copy()
    _properties.update({
        'macro' : 'jidTreeVocabularyWidget',
        ##code-section widget-properties #fill in your manual code here

        #vocabulary name with data
        'vocabulary_name': 'branches',
        #number of levels in the dictionary tree
        'level_numbers': 3,
        #indicates if widget is multiselect at the last level - possible values ['multiselect','singleselect']
        'selection_type':'multiselect',

        ##/code-section widget-properties
        })

    security = ClassSecurityInfo()

    def fillSelection(self,context,request):
        """Fills selection with data
        """
        #set selected values array
        selected_values = []
        selectionControlNumber = int(request['selectionControlNumber'])
        field_name = request['jidTreeVocabularyWidgetFieldName']
        for number in range(1, selectionControlNumber+1):
            if isinstance(request[field_name+'_selection'+str(number)], ListType):
                for item in request[field_name+'_selection'+str(number)]:
                    selected_values.append(item)
            else:
                selected_values.append(request[field_name+'_selection'+str(number)])

        self.setSessionWidgetSelectedValues(field_name, request, selected_values)
        self.context = context

        return self.populateSelectionTemplate()

    def clearSelection(self,context,request):
        """Clears selection from data
        """
        self.context = context
        return self.clearSelectionTemplate()

    def getValues(self, context, level, upper_level_key=None, fieldName=None):
        """Gets values from given level for selection control
        """
        request = context.REQUEST

        if fieldName is not None:
            field_name = fieldName
        else:
            field_name = request['jidTreeVocabularyWidgetFieldName']

        field_vocab_data = self.getVocabularyData(context=context, fieldName=field_name)
        portal_vocabulary = getToolByName(context, 'portal_vocabularies')
        vocab = portal_vocabulary.getVocabularyByName(self.vocabulary_name)
        keys = vocab.keys()

        for current_level in range(1, int(self.level_numbers)+1):
            if current_level == level:
                break
            else:
                vocab = vocab[field_vocab_data[field_name+'_selection'+str(current_level)][0]]
                keys = vocab.keys()

        keys_array = []
        for key in keys:
            keys_array.append((key, vocab[key].getTermValue()))

        return keys_array

    def getValuesForSelection(self, context, level):
        """Gets values for populating selection control
        """
        request = context.REQUEST
        field_name = request['jidTreeVocabularyWidgetFieldName']
        portal_vocabulary = getToolByName(context, 'portal_vocabularies')
        vocab = portal_vocabulary.getVocabularyByName(self.vocabulary_name)
        keys = vocab.keys()

        for current_level in range(1, int(self.level_numbers)+1):
            if current_level == level:
                break
            else:
                key = request[field_name+'_selection'+str(current_level)]
                vocab = vocab[key]
                keys = vocab.keys()

        keys_array = []
        for key in keys:
            keys_array.append((key, vocab[key].getTermValue()))

        return keys_array

    def setVocabularyData(self, context, key, values_array, field_name):
        """Sets values for the given selection field key
        """
        vocab_field_name = field_name+config.FIELD_VIEW_POSTFIX
        if not safe_hasattr(context, vocab_field_name):
            context.__setattr__(vocab_field_name, {})

        vocab = context.__getattribute__(vocab_field_name)
        vocab[key] = values_array

        context.__setattr__(vocab_field_name, vocab)

        return

    def getVocabularyData(self, context, fieldName=None):
        """Returns vocabulary with selected vaule including tree levels
        """
        if fieldName is not None:
            field_name = fieldName
        else:
            field_name = request['jidTreeVocabularyWidgetFieldName']
        vocab_field_name = field_name+config.FIELD_VIEW_POSTFIX

        if safe_hasattr(context, vocab_field_name):
            return context.__getattribute__(vocab_field_name)
        else:
            return {}

    def resetVocabularyProperty(self, instance, field_name):
        """Resets vocabulary field
        """
        vocab_field_name = field_name+config.FIELD_VIEW_POSTFIX
        instance.__setattr__(vocab_field_name, {})

        return

    def getWidgetSelectedValues(self,context,request,fieldName):
        """Returns list of selected values
        """
        if request.has_key(self.getWidgetSelValsVariableName(fieldName)):
            return self.getSessionWidgetSelectedValues(fieldName, request)
        else:
            field = context.getField(fieldName)
            items = field.getAccessor(context)()
            if items is None:
                self.setSessionWidgetSelectedValues(fieldName, request, [])
            else:
                self.setSessionWidgetSelectedValues(fieldName, request, [value for value in items])

            return self.getSessionWidgetSelectedValues(fieldName, request)


    def process_form(self,instance,field,form,empty_marker=None,emptyReturnsMarker=False,validating=True):
        """Returns values from the widget during 'save edit form' action
        """
        #write values to the additional field, first clear previously saved data
        self.resetVocabularyProperty(instance=instance, field_name=field.getName())

        for number in range(1, self.level_numbers+1):
            key = field.getName()+'_selection'+str(number)
            values_array = []
            if key in instance.REQUEST.keys():
                vals = instance.REQUEST.get(key)

                if isinstance(vals, StringTypes):
                   values_array.append(vals)
                else:
                    for val in vals:
                        values_array.append(val)

                self.setVocabularyData(context=instance, key=field.getName()+'_selection'+str(number), values_array=values_array, field_name=field.getName())

                #########
                #DEBUG#
                #########
                if field.getName() == 'branchMain':
# and self.checkRequirement(instance, field)
                    value = self.getWidgetSelectedValues(instance, instance.REQUEST, field.getName())
                    if isinstance(value, StringTypes):
                        values = [v.strip() for v in value.split('\n')]
                    elif isinstance(value, ListType):
                        values = value
                    else:
                        values = []

                    #attach request to the log
                    prepared_request = ''
                    for key_req in instance.REQUEST.keys():
                        prepared_request += '\n%s: %s' % (str(key_req), str(instance.REQUEST.get(key_req)))

                    log('DEBUG: jidTreeVocabularyWidget, key: %s\nfield_name: %s\nrequirement: %s\nvalues (written to the objects target attribute - got from widget data): %s\n' % (str(key), str(field.getName()), str(self.checkRequirement(instance, field)), str(values)))
                #########
                #DEBUG#
                #########

            #########
            #DEBUG#
            #########
            #there is no key *_selection3 for branchMain and no data is beeing written to the context object additional attribute
            else:
                try:
                    if field.getName() == 'branchMain':
                        value = self.getWidgetSelectedValues(instance, instance.REQUEST, field.getName())
                        if isinstance(value, StringTypes):
                            values = [v.strip() for v in value.split('\n')]
                        elif isinstance(value, ListType):
                            values = value
                        else:
                            values = []

                        #attach request to the log
                        prepared_request = ''
                        for key_req in instance.REQUEST.keys():
                            prepared_request += '\n%s: %s' % (str(key_req), str(instance.REQUEST.get(key_req)))

                        log_exc('jidTreeVocabularyWidget - no selection key in request: %s\n\nfield_name: %s\nrequirement: %s\nvalues (written to the objects target attribute - got from widget data): %s\n\n\nREQUEST%s' % (str(key), str(field.getName()), str(self.checkRequirement(instance, field)), str(values), prepared_request))
                except Exception, exc:
                    log_exc('jidTreeVocabularyWidget error in process_form' + str(exc))
                    pass
            #########
            #DEBUG#
            #########


        # Validate requirement property of the field
        if field.required:
            filled = self.checkRequirement(instance, field)
            if not filled:
                return [], {}

        #return value of the field
        value = self.getWidgetSelectedValues(instance, instance.REQUEST, field.getName())

        if value is empty_marker:
            return empty_marker
        if emptyReturnsMarker and value == '':
            return empty_marker
        if isinstance(value, StringTypes):
            values = [v.strip() for v in value.split('\n')]
        elif isinstance(value, ListType):
            values = value
        else:
            values = []

        #DEBUG#
#        if field.getName() == 'branchMain':
#            log('jidTreeVocabularyWidget ---- values_array (written to the objects additional attribute): ' + str(values_array) + ' ; field_name: ' + str(field.getName()) + ' ; values (written to the objects target attribute): ' + str(values))

#        if values <> values_array:
#            log_exc('jidTreeVocabularyWidget - Array of values from widget is different from the array of values from the context object.\n' + 'values_array (written to the objects additional attribute): ' + str(values_array) + ' ; field_name: ' + str(field.getName()) + ' ; values (written to the objects target attribute): ' + str(values))
        #DEBUG#

        return values, {}

    def checkRequirement(self, context, field):
        """Check if widget has been filled properly
        """
        values_vocab_field_name = field.getName()+config.FIELD_VIEW_POSTFIX
        values_vocab = context.__getattribute__(values_vocab_field_name)
        required_level_key = field.getName()+'_selection'+str(self.level_numbers)

        if required_level_key in values_vocab.keys():
            return True
        else:
            return False

    def getValuesForViewMacro(self, context, fieldName):
        """Returns values to display in View mode
        """
        values = ''
        saved_data = self.getVocabularyData(context, fieldName)
        key = None

        for number in range(self.level_numbers, 0, -1):
            key = fieldName+'_selection'+str(number)
            if key in saved_data.keys():
                break
            key = None

        if not key == None:
            vocab_vals = saved_data[key]
            for val in vocab_vals:
                values+=val+','
        if not values == '':
            values = values[0:-1]

        return values

    def setLastLevelValues(self, values, field_name, request):
        """Appends last node level selected values to the selected values variable
            values = values selected at last level
        """
        selected_values = []
        for number in range(1, self.level_numbers):
            if isinstance(request[field_name+'_selection'+str(number)], ListType):
                for item in request[field_name+'_selection'+str(number)]:
                    selected_values.append(item)
            else:
                selected_values.append(request[field_name+'_selection'+str(number)])

        if isinstance(values, ListType):
            for item in values:
                selected_values.append(item)
        else:
            selected_values.append(values)

        self.setSessionWidgetSelectedValues(field_name, request, selected_values)

        return

    def setSessionWidgetSelectedValues(self, field_name, request, selected_values):
        """Sets selected values in SESSION variable
        """
        #sets string with values separated by comma
        val_string = ''
        for item in selected_values:
            val_string += item+','

        if len(selected_values) > 0:
            val_string = val_string[:-1]

        request.set(self.getWidgetSelValsVariableName(field_name), val_string)
        return

    def getSessionWidgetSelectedValues(self, field_name, request):
        """Gets array of selected values
        """
        value = request.get(self.getWidgetSelValsVariableName(field_name), '')
        values_array = []

        for val in value.split(','):
            if not val.strip() == '':
                values_array.append(val)

        return values_array

    def getWidgetSelValsVariableName(self, field_name):
        """Returns name of the variable containing temporarly selected values
        """
        return field_name+'_widgetSelectedValues'

    def getInitialWidgetSelectedValuesString(self, context, field_name, request):
        """Gets initial values for the edit form
        """
        vals = ''
        field = context.getField(field_name)
        items = field.getAccessor(context)()
        if items is None:
            return vals

        for val in items:
            if not val.strip() == '':
                vals += val + ','
        if not vals == '':
            vals = vals[0:-1]

        return vals

registerWidget(jidTreeVocabularyWidget,
               title='jidTreeVocabularyWidget',
               description=('no description given'),
               used_for=('Products.Archetypes.Field.StringField',)
               )
##code-section module-footer #fill in your manual code here
##/code-section module-footer



